package exnihilocreatio.blocks;

import exnihilocreatio.ModBlocks;
import exnihilocreatio.compatibility.ITOPInfoProvider;
import exnihilocreatio.config.ModConfig;
import exnihilocreatio.items.tools.ICrook;
import exnihilocreatio.tiles.TileInfestedLeaves;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import exnihilocreatio.util.Util;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.Block;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.BlockPlanks.EnumType;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class BlockInfestedLeaves extends BlockLeaves implements ITileEntityProvider, ITOPInfoProvider, IHasModel {
    private int[] surroundings;

    public BlockInfestedLeaves() {
        super();
        this.func_149663_c("block_infested_leaves");
        this.setRegistryName("block_infested_leaves");
        Data.BLOCKS.add(this);
        this.func_180632_j(
                this.field_176227_L.func_177621_b().func_177226_a(field_176236_b, false).func_177226_a(field_176237_a, true));
        this.field_185686_c = true;
    }

    public static void infestLeafBlock(World world, BlockPos pos) {
        IBlockState block = world.func_180495_p(pos);

        if (block.func_177230_c().isLeaves(block, world, pos) && !block.func_177230_c().equals(ModBlocks.infestedLeaves)) {
            world.func_175656_a(pos, ModBlocks.infestedLeaves.func_176223_P());

            TileInfestedLeaves tile = (TileInfestedLeaves) world.func_175625_s(pos);

            if (tile != null) {
                tile.setLeafBlock(block);
            }
        }
    }

    @Override
    @Nonnull
    @Deprecated
    public EnumBlockRenderType func_149645_b(IBlockState state) {
        return EnumBlockRenderType.ENTITYBLOCK_ANIMATED;
    }

    @Override
    @Nonnull
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, field_176236_b, field_176237_a);
    }

    @Override
    @Nonnull
    @Deprecated
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(field_176236_b, meta == 0 || meta == 1).func_177226_a(field_176237_a, meta == 0 || meta == 2);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        boolean checkDecay = state.func_177229_b(field_176236_b);
        boolean decayable = state.func_177229_b(field_176237_a);
        if (checkDecay && decayable)
            return 0;
        if (checkDecay)
            return 1;
        if (decayable)
            return 2;
        return 3;
    }

    @Override
    @Nonnull
    public List<ItemStack> getDrops(@Nonnull IBlockAccess world, @Nonnull BlockPos pos, @Nonnull IBlockState state, int fortune) {
        return new ArrayList<>();
    }

    @Override
    public void func_180650_b(World worldIn, @Nonnull BlockPos pos, @Nonnull IBlockState state, Random rand) {
        if (!worldIn.field_72995_K) {
            if (state.func_177229_b(field_176236_b) && state.func_177229_b(field_176237_a)) {
                int posX = pos.func_177958_n();
                int posY = pos.func_177956_o();
                int posZ = pos.func_177952_p();

                if (this.surroundings == null) {
                    this.surroundings = new int[32768];
                }

                if (worldIn.func_175707_a(new BlockPos(posX - 5, posY - 5, posZ - 5), new BlockPos(posX + 5, posY + 5, posZ + 5))) {
                    BlockPos.MutableBlockPos blockpos$mutableblockpos = new BlockPos.MutableBlockPos();

                    for (int i2 = -4; i2 <= 4; ++i2) {
                        for (int j2 = -4; j2 <= 4; ++j2) {
                            for (int k2 = -4; k2 <= 4; ++k2) {
                                IBlockState iblockstate = worldIn.func_180495_p(blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2));
                                Block block = iblockstate.func_177230_c();

                                if (!block.canSustainLeaves(iblockstate, worldIn, blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2))) {
                                    if (block.isLeaves(iblockstate, worldIn, blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2))) {
                                        this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = -2;
                                    } else {
                                        this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = -1;
                                    }
                                } else {
                                    this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = 0;
                                }
                            }
                        }
                    }

                    for (int i3 = 1; i3 <= 4; ++i3) {
                        for (int j3 = -4; j3 <= 4; ++j3) {
                            for (int k3 = -4; k3 <= 4; ++k3) {
                                for (int l3 = -4; l3 <= 4; ++l3) {
                                    if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16] == i3 - 1) {
                                        if (this.surroundings[(j3 + 16 - 1) * 1024 + (k3 + 16) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16 - 1) * 1024 + (k3 + 16) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16 + 1) * 1024 + (k3 + 16) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16 + 1) * 1024 + (k3 + 16) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16 - 1) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16 - 1) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16 + 1) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16 + 1) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + (l3 + 16 - 1)] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + (l3 + 16 - 1)] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16 + 1] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16 + 1] = i3;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                int l2 = this.surroundings[16912];

                if (l2 < 0) {
                    this.func_176235_d(worldIn, pos);
                }
            }
        }
    }

    @Override
    public void func_176235_d(World worldIn, @Nonnull BlockPos pos) {
        if (worldIn.field_73012_v.nextInt(3) == 0) {
            TileEntity te = worldIn.func_175625_s(pos);
            if (te != null && te instanceof TileInfestedLeaves) {
                TileInfestedLeaves infestedLeaves = (TileInfestedLeaves) te;
                if (worldIn.field_73012_v.nextFloat() < infestedLeaves.getProgress() * ModConfig.crooking.stringChance / 4.0d) {
                    func_180635_a(worldIn, pos, new ItemStack(Items.field_151007_F));
                }
            }
        }
        super.func_176235_d(worldIn, pos);
    }

    @Override
    public void func_176208_a(World world, BlockPos pos, IBlockState state, EntityPlayer player) {
        if (!world.field_72995_K && !player.func_184812_l_()) {
            TileEntity tile = world.func_175625_s(pos);

            if (tile != null) {
                if (tile instanceof TileInfestedLeaves) {
                    TileInfestedLeaves leaves = (TileInfestedLeaves) tile;

                    if (!player.func_184614_ca().func_190926_b()
                            && player.func_184614_ca().func_77973_b() instanceof ICrook) {
                        if (world.field_73012_v.nextFloat() < leaves.getProgress() * ModConfig.crooking.stringChance) {
                            Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);
                        }

                        if (world.field_73012_v.nextFloat() < leaves.getProgress() * ModConfig.crooking.stringChance / 4.0d) {
                            Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);
                        }
                    }
                }

                world.func_175713_t(pos);
            }
        }
    }

    @Override
    public List<ItemStack> onSheared(@Nonnull ItemStack item, IBlockAccess world, BlockPos pos, int fortune) {
        ArrayList<ItemStack> ret = new ArrayList<>();
        ret.add(new ItemStack(this));
        return ret;
    }

    @Override
    @Nonnull
    public EnumType func_176233_b(int meta) {
        return EnumType.OAK;
    }

    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileInfestedLeaves();
    }

    @Override
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {

        TileInfestedLeaves tile = (TileInfestedLeaves) world.func_175625_s(data.getPos());

        if (tile != null) {
            if (tile.getProgress() >= 1.0F) {
                probeInfo.text("Progress: Done");
            } else {
                probeInfo.progress((int) (tile.getProgress() * 100), 100);
            }
        }
    }
}
