package exnihilocreatio.networking;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class MessageNBTUpdate implements IMessage {

    private int x, y, z;
    private NBTTagCompound tag;

    public MessageNBTUpdate() {
    }

    public MessageNBTUpdate(TileEntity te) {
        this.x = te.func_174877_v().func_177958_n();
        this.y = te.func_174877_v().func_177956_o();
        this.z = te.func_174877_v().func_177952_p();
        this.tag = te.func_189515_b(new NBTTagCompound());
    }

    @Override
    public void toBytes(ByteBuf buf) {
        buf.writeInt(x);
        buf.writeInt(y);
        buf.writeInt(z);
        ByteBufUtils.writeTag(buf, tag);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        this.x = buf.readInt();
        this.y = buf.readInt();
        this.z = buf.readInt();
        this.tag = ByteBufUtils.readTag(buf);
    }

    public static class MessageNBTUpdateHandler implements IMessageHandler<MessageNBTUpdate, IMessage> {
        @Override
        @SideOnly(Side.CLIENT)
        public IMessage onMessage(final MessageNBTUpdate msg, MessageContext ctx) {
            Minecraft.func_71410_x().func_152344_a(new Runnable() {
                @Override
                @SideOnly(Side.CLIENT)
                public void run() {
                    TileEntity entity = Minecraft.func_71410_x().field_71439_g.func_130014_f_().func_175625_s(new BlockPos(msg.x, msg.y, msg.z));

                    if (entity != null) {
                        entity.func_145839_a(msg.tag);
                    }
                }
            });
            return null;
        }
    }

}
